/* Fo
 * fo-footnote_body.h: Footnote Body formatting object
 *
 * Copyright (C) 2001 Sun Microsystems
 *
 * $Id: fo-footnote-body.h,v 1.2 2003/03/19 21:11:06 tonygraham Exp $
 *
 * See Copyright for the status of this software.
 */

#ifndef __FO_FOOTNOTE_BODY_H__
#define __FO_FOOTNOTE_BODY_H__

#include <libfo/fo-utils.h>

#include <fo-property-role.h>
#include <fo-property-source-document.h>

G_BEGIN_DECLS

typedef struct _FoFootnoteBody      FoFootnoteBody;
typedef struct _FoFootnoteBodyClass FoFootnoteBodyClass;

#define FO_TYPE_FOOTNOTE_BODY              (fo_footnote_body_get_type ())
#define FO_FOOTNOTE_BODY(object)           (G_TYPE_CHECK_INSTANCE_CAST ((object), FO_TYPE_FOOTNOTE_BODY, FoFootnoteBody))
#define FO_FOOTNOTE_BODY_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST ((klass), FO_TYPE_FOOTNOTE_BODY, FoFootnoteBodyClass))
#define FO_IS_FOOTNOTE_BODY(object)        (G_TYPE_CHECK_INSTANCE_TYPE ((object), FO_TYPE_FOOTNOTE_BODY))
#define FO_IS_FOOTNOTE_BODY_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), FO_TYPE_FOOTNOTE_BODY))
#define FO_FOOTNOTE_BODY_GET_CLASS(obj)    (G_TYPE_INSTANCE_GET_CLASS ((obj), FO_TYPE_FOOTNOTE_BODY, FoFootnoteBodyClass))


GType         fo_footnote_body_get_type      (void) G_GNUC_CONST;
FoFo *fo_footnote_body_new (void);

void fo_footnote_body_update_from_context (FoFo *fo,
				   FoContext *context);
void fo_footnote_body_set_role (FoFootnoteBody *fo_footnote_body,
		      FoPropertyRole *new_role);
FoPropertyRole* fo_footnote_body_get_role (FoFootnoteBody *fo_footnote_body);
void fo_footnote_body_set_source_document (FoFootnoteBody *fo_footnote_body,
		      FoPropertySourceDocument *new_source_document);
FoPropertySourceDocument* fo_footnote_body_get_source_document (FoFootnoteBody *fo_footnote_body);

G_END_DECLS

#endif /* !__FO_FOOTNOTE_BODY_H__ */
