/* Fo
 * fo-property-alignment-baseline.h: 'alignment-baseline' property
 *
 * Copyright (C) 2001 Sun Microsystems
 *
 * $Id: fo-property-alignment-baseline.h,v 1.3 2003/03/21 14:40:41 tonygraham Exp $
 *
 * See Copying for the status of this software.
 */

#ifndef __FO_PROPERTY_ALIGNMENT_BASELINE_H__
#define __FO_PROPERTY_ALIGNMENT_BASELINE_H__

#include <libfo/fo-utils.h>
#include "fo-property.h"

G_BEGIN_DECLS

/* alignment-baseline */
/* auto | baseline | before-edge | text-before-edge | middle | central | after-edge | text-after-edge | ideographic | alphabetic | hanging | mathematical | inherit */
/* Initial value: auto */
typedef enum {
  FO_ENUM_ALIGNMENT_BASELINE_AUTO,
  FO_ENUM_ALIGNMENT_BASELINE_BASELINE,
  FO_ENUM_ALIGNMENT_BASELINE_BEFORE_EDGE,
  FO_ENUM_ALIGNMENT_BASELINE_TEXT_BEFORE_EDGE,
  FO_ENUM_ALIGNMENT_BASELINE_MIDDLE,
  FO_ENUM_ALIGNMENT_BASELINE_CENTRAL,
  FO_ENUM_ALIGNMENT_BASELINE_AFTER_EDGE,
  FO_ENUM_ALIGNMENT_BASELINE_TEXT_AFTER_EDGE,
  FO_ENUM_ALIGNMENT_BASELINE_IDEOGRAPHIC,
  FO_ENUM_ALIGNMENT_BASELINE_ALPHABETIC,
  FO_ENUM_ALIGNMENT_BASELINE_HANGING,
  FO_ENUM_ALIGNMENT_BASELINE_MATHEMATICAL
} FoEnumAlignmentBaseline;

GType fo_enum_alignment_baseline_get_type (void);
#define FO_TYPE_ENUM_ALIGNMENT_BASELINE fo_enum_alignment_baseline_get_type ()

#define FO_TYPE_PROPERTY_ALIGNMENT_BASELINE              (fo_property_alignment_baseline_get_type ())
#define FO_PROPERTY_ALIGNMENT_BASELINE(object)           (G_TYPE_CHECK_INSTANCE_CAST ((object), FO_TYPE_PROPERTY_ALIGNMENT_BASELINE, FoPropertyAlignmentBaseline))
#define FO_PROPERTY_ALIGNMENT_BASELINE_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST ((klass), FO_TYPE_PROPERTY_ALIGNMENT_BASELINE, FoPropertyAlignmentBaselineClass))
#define FO_IS_PROPERTY_ALIGNMENT_BASELINE(object)        (G_TYPE_CHECK_INSTANCE_TYPE ((object), FO_TYPE_PROPERTY_ALIGNMENT_BASELINE))
#define FO_IS_PROPERTY_ALIGNMENT_BASELINE_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), FO_TYPE_PROPERTY_ALIGNMENT_BASELINE))
#define FO_PROPERTY_ALIGNMENT_BASELINE_GET_CLASS(obj)    (G_TYPE_INSTANCE_GET_CLASS ((obj), FO_TYPE_PROPERTY_ALIGNMENT_BASELINE, FoPropertyAlignmentBaselineClass))


typedef struct _FoPropertyAlignmentBaseline      FoPropertyAlignmentBaseline;
typedef struct _FoPropertyAlignmentBaselineClass FoPropertyAlignmentBaselineClass;

GType       fo_property_alignment_baseline_get_type    (void) G_GNUC_CONST;
FoProperty* fo_property_alignment_baseline_new         (void);
FoProperty* fo_property_alignment_baseline_get_initial (void);

G_END_DECLS

#endif /* !__FO_PROPERTY_ALIGNMENT_BASELINE_H__ */
