/* Fo
 * fo-property-border-before-precedence.c: 'border-before-precedence' property
 *
 * Copyright (C) 2001 Sun Microsystems
 *
 * $Id: fo-property-border-before-precedence.c,v 1.3 2003/06/30 13:10:33 tonygraham Exp $
 *
 * See Copying for the status of this software.
 */

#include <string.h>
#include "libfo/fo-utils.h"
#include "fo-context.h"
#include "datatype/fo-datatype.h"
#include "property/fo-property-private.h"
#include "property/fo-property-font-size.h"
#include "property/fo-property-border-before-precedence.h"

/* Inherited: FALSE */
/* Shorthand: FALSE */
/* border-before-precedence */
/* force | <integer> | inherit */
GType
fo_enum_border_before_precedence_get_type (void)
{
  static GType etype = 0;
  if (etype == 0)
    {
      static const GEnumValue values[] = {
        { FO_ENUM_BORDER_BEFORE_PRECEDENCE_FORCE, "FO_ENUM_BORDER_BEFORE_PRECEDENCE_FORCE", "force" },
        { 0, NULL, NULL }
      };
      etype = g_enum_register_static ("FoEnumBorderBeforePrecedence", values);
    }
  return etype;
}

struct _FoPropertyBorderBeforePrecedence
{
  FoProperty parent_instance;
};

struct _FoPropertyBorderBeforePrecedenceClass
{
  FoPropertyClass parent_class;
};

static void fo_property_border_before_precedence_init         (FoPropertyBorderBeforePrecedence      *property_border_before_precedence);
static void fo_property_border_before_precedence_base_init   (FoPropertyBorderBeforePrecedenceClass *klass);
static void fo_property_border_before_precedence_base_finalize   (FoPropertyBorderBeforePrecedenceClass *klass);
static void fo_property_border_before_precedence_class_init   (FoPropertyBorderBeforePrecedenceClass *klass);
static void fo_property_border_before_precedence_finalize     (GObject       *object);

static FoDatatype* fo_property_border_before_precedence_resolve_enum (const gchar *token,
                                                                      FoContext   *context,
                                                                      GError     **error);
static FoDatatype* fo_property_border_before_precedence_validate (FoDatatype *datatype,
                                                                  FoContext  *context,
                                                                  GError    **error);

static const gchar class_name[] = "border-before-precedence";
static gpointer parent_class;
static FoDatatype *enum_force;

/**
 * fo_property_border_before_precedence_get_type:
 * 
 * Register the #FoPropertyBorderBeforePrecedence type if not already registered and
 * return its #GType value.
 * 
 * Return value: #GType of #FoPropertyBorderBeforePrecedence.
 **/
GType
fo_property_border_before_precedence_get_type (void)
{
  static GType object_type = 0;

  if (!object_type)
    {
      static const GTypeInfo object_info =
      {
        sizeof (FoPropertyBorderBeforePrecedenceClass),
        (GBaseInitFunc) fo_property_border_before_precedence_base_init,
        (GBaseFinalizeFunc) fo_property_border_before_precedence_base_finalize,
        (GClassInitFunc) fo_property_border_before_precedence_class_init,
        NULL,           /* class_finalize */
        NULL,           /* class_data */
        sizeof (FoPropertyBorderBeforePrecedence),
        0,              /* n_preallocs */
        (GInstanceInitFunc) fo_property_border_before_precedence_init,
	NULL		/* value_table */
      };

      object_type = g_type_register_static (FO_TYPE_PROPERTY,
                                            class_name,
                                            &object_info, 0);
    }

  return object_type;
}

/**
 * fo_property_border_before_precedence_init:
 * @border_before_precedence: #FoPropertyBorderBeforePrecedence object to initialise.
 * 
 * Implements #GInstanceInitFunc for #FoPropertyBorderBeforePrecedence.
 **/
void
fo_property_border_before_precedence_init (FoPropertyBorderBeforePrecedence *border_before_precedence)
{
  FO_PROPERTY (border_before_precedence)->value =
    NULL;
}

/**
 * fo_property_border_before_precedence_base_init:
 * @klass: #FoPropertyBorderBeforePrecedenceClass object to initialise.
 * 
 * Implements #GBaseInitFunc for #FoPropertyBorderBeforePrecedenceClass.
 **/
void
fo_property_border_before_precedence_base_init (FoPropertyBorderBeforePrecedenceClass *klass)
{
  enum_force =
    g_object_new (FO_TYPE_ENUM,
                  "enum-class",
                  g_type_class_ref (FO_TYPE_ENUM_BORDER_BEFORE_PRECEDENCE),
                  "value",
                  FO_ENUM_BORDER_BEFORE_PRECEDENCE_FORCE,
                  NULL);
}

/**
 * fo_property_border_before_precedence_base_finalize:
 * @klass: #FoPropertyBorderBeforePrecedenceClass object to finalise.
 * 
 * Implements #GBaseFinalizeFunc for #FoPropertyBorderBeforePrecedenceClass.
 **/
void
fo_property_border_before_precedence_base_finalize (FoPropertyBorderBeforePrecedenceClass *klass)
{
  g_object_unref (enum_force);
}

/**
 * fo_property_border_before_precedence_class_init:
 * @klass: #FoPropertyBorderBeforePrecedenceClass object to initialise.
 * 
 * Implements #GClassInitFunc for #FoPropertyBorderBeforePrecedenceClass.
 **/
void
fo_property_border_before_precedence_class_init (FoPropertyBorderBeforePrecedenceClass *klass)
{
  GObjectClass *object_class = G_OBJECT_CLASS (klass);
  FoPropertyClass *property_class = FO_PROPERTY_CLASS (klass);

  parent_class = g_type_class_peek_parent (klass);

  object_class->finalize = fo_property_border_before_precedence_finalize;

  property_class->is_inherited = FALSE;
  property_class->is_shorthand = FALSE;
  property_class->resolve_enum =
    fo_property_border_before_precedence_resolve_enum;
  property_class->validate =
    fo_property_border_before_precedence_validate;
  property_class->get_initial =
    fo_property_border_before_precedence_get_initial;
}

/**
 * fo_property_border_before_precedence_finalize:
 * @object: #FoPropertyBorderBeforePrecedence object to finalize.
 * 
 * Implements #GObjectFinalizeFunc for #FoPropertyBorderBeforePrecedence.
 **/
void
fo_property_border_before_precedence_finalize (GObject *object)
{
  FoPropertyBorderBeforePrecedence *border_before_precedence;

  border_before_precedence = FO_PROPERTY_BORDER_BEFORE_PRECEDENCE (object);

  G_OBJECT_CLASS (parent_class)->finalize (object);
}


/**
 * fo_property_border_before_precedence_new:
 * 
 * Creates a new #FoPropertyBorderBeforePrecedence initialized to default value.
 * 
 * Return value: the new #FoPropertyBorderBeforePrecedence.
 **/
FoProperty*
fo_property_border_before_precedence_new (void)
{
  FoProperty* border_before_precedence;

  border_before_precedence =
    FO_PROPERTY (g_object_new (fo_property_border_before_precedence_get_type (),
                               NULL));

  return border_before_precedence;
}

/**
 * fo_property_border_before_precedence_resolve_enum:
 * @token:   Token from the XML attribute value to be evaluated as an
 *           enumeration token.
 * @context: #FoContext object from which to possibly inherit values.
 * @error:   Information about any error that has occurred.
 * 
 * Compare @token against the enumeration tokens that are valid for the
 * current FO property.  If @token is valid, returns either an #FoEnum datatype
 * representing the enumeration token or a different datatype representing
 * the enumeration token's resolved value.  If @token is not valid,
 * sets @error and returns NULL.
 * 
 * Return value: Resolved enumeration value or NULL.
 **/
FoDatatype*
fo_property_border_before_precedence_resolve_enum (const gchar *token,
                                                   FoContext   *context,
                                                   GError     **error)
{
  g_return_val_if_fail (token != NULL, NULL);
  g_return_val_if_fail (FO_IS_CONTEXT (context), NULL);
  g_return_val_if_fail (error == NULL || *error == NULL, NULL);

  if (strcmp (token, "force") == 0)
    {
      return g_object_ref (enum_force);
    }
  else
    {
      g_set_error (error,
		   FO_FO_ERROR,
		   FO_FO_ERROR_ENUMERATION_TOKEN,
		   _(fo_fo_error_messages[FO_FO_ERROR_ENUMERATION_TOKEN]),
		   class_name,
		   token);
      return NULL;
    }
}

/**
 * fo_property_border_before_precedence_validate:
 * @datatype: #FoDatatype to be validated against allowed datatypes and
 *            values for current property.
 * @context:  #FoContext object from which to possibly inherit values.
 * @error:    Information about any error that has occurred.
 * 
 * Validates @datatype against allowed values.  Returns @datatype, a
 * replacement datatype value, or NULL if validation failed.
 * 
 * Return value: Valid datatype value or NULL.
 **/
FoDatatype*
fo_property_border_before_precedence_validate (FoDatatype *datatype,
                                               FoContext  *context,
                                               GError    **error)
{
  FoDatatype *new_datatype;
  GError     *tmp_error = NULL;
  gchar      *token;

  g_return_val_if_fail (datatype != NULL, NULL);
  g_return_val_if_fail (FO_IS_DATATYPE (datatype), NULL);
  g_return_val_if_fail (context != NULL, NULL);
  g_return_val_if_fail (FO_IS_CONTEXT (context), NULL);
  g_return_val_if_fail (error == NULL || *error == NULL, NULL);

  if (FO_IS_ENUM (datatype))
    {
      if ((G_ENUM_CLASS_TYPE (fo_enum_get_enum_class (datatype))
           == FO_TYPE_ENUM_BORDER_BEFORE_PRECEDENCE) &&
	  (g_enum_get_value (fo_enum_get_enum_class (datatype),
			     fo_enum_get_value (datatype)) != NULL))
	{
	  return datatype;
	}
      else
	{
	  gchar *datatype_sprintf = fo_object_sprintf (datatype);

	  g_set_error (error,
		       FO_FO_ERROR,
		       FO_FO_ERROR_DATATYPE,
		       _(fo_fo_error_messages[FO_FO_ERROR_DATATYPE]),
		       class_name,
		       datatype_sprintf,
		       g_type_name (G_TYPE_FROM_INSTANCE (datatype)));

	  g_object_unref (datatype);

	  g_free (datatype_sprintf);

	  return NULL;
	}
    }
  else if (FO_IS_STRING (datatype))
    {
      token = fo_string_get_value (datatype);

      new_datatype =
        fo_property_border_before_precedence_resolve_enum (token, context, &tmp_error);

      g_object_unref (datatype);

      if (tmp_error != NULL)
	{
	  g_propagate_error (error, tmp_error);
	  return NULL;
	}

      return new_datatype;
    }
  else if (FO_IS_NAME (datatype))
    {
      token = fo_name_get_value (datatype);

      new_datatype =
        fo_property_border_before_precedence_resolve_enum (token, context, &tmp_error);

      g_object_unref (datatype);

      if (tmp_error != NULL)
	{
	  g_propagate_error (error, tmp_error);
	  return NULL;
	}

      return new_datatype;
    }
  else if (FO_IS_INTEGER (datatype))
    {
      return datatype;
    }
  else
    {
      gchar *datatype_sprintf = fo_object_sprintf (datatype);

      g_set_error (error,
		   FO_FO_ERROR,
		   FO_FO_ERROR_DATATYPE,
		   _(fo_fo_error_messages[FO_FO_ERROR_DATATYPE]),
		   class_name,
		   datatype_sprintf,
		   g_type_name (G_TYPE_FROM_INSTANCE (datatype)));

      g_object_unref (datatype);

      g_free (datatype_sprintf);

      return NULL;
    }
}

/**
 * fo_property_border_before_precedence_get_initial:
 * 
 * Get an instance of the property with the correct initial value.
 * 
 * Return value: An instance of the property.
 **/
FoProperty*
fo_property_border_before_precedence_get_initial (void)
{
  static FoProperty *border_before_precedence = NULL;

  if (border_before_precedence == NULL)
    {
      border_before_precedence = fo_property_border_before_precedence_new ();
    }

  return border_before_precedence;
}
