/* Fo
 * fo-property-border-private.h: Structures private to common border property definitions
 *
 * Copyright (C) 2001 Sun Microsystems
 *
 * $Id: fo-property-border-private.h,v 1.3 2003/03/21 14:41:09 tonygraham Exp $
 *
 * See Copying for the status of this software.
 */

#ifndef __FO_PROPERTY_BORDER_PRIVATE_H__
#define __FO_PROPERTY_BORDER_PRIVATE_H__

#include <fo-property-private.h>
#include <fo-property-border.h>

G_BEGIN_DECLS

struct _FoPropertyBorder
{
  FoProperty parent_instance;
};

struct _FoPropertyBorderClass
{
  FoPropertyClass parent_class;
};

FoDatatype* fo_property_border_resolve_width_enum (const gchar *token,
						   FoContext   *context,
						   GError     **error);
FoDatatype* fo_property_border_validate_width (FoDatatype *datatype,
					       FoContext  *context,
					       GError    **error);
FoDatatype* fo_property_border_get_width_initial (void);

FoDatatype* fo_property_border_resolve_style_enum (const gchar *token,
						   FoContext   *context,
						   GError     **error);
FoDatatype* fo_property_border_validate_style (FoDatatype *datatype,
					       FoContext  *context,
					       GError    **error);
FoDatatype* fo_property_border_get_style_initial (void);

G_END_DECLS

#endif /* !__FO_PROPERTY_BORDER_PRIVATE_H__ */
