/* Fo
 * fo-property-dominant-baseline.h: 'dominant-baseline' property
 *
 * Copyright (C) 2001 Sun Microsystems
 *
 * $Id: fo-property-dominant-baseline.h,v 1.3 2003/03/21 14:41:29 tonygraham Exp $
 *
 * See Copying for the status of this software.
 */

#ifndef __FO_PROPERTY_DOMINANT_BASELINE_H__
#define __FO_PROPERTY_DOMINANT_BASELINE_H__

#include <libfo/fo-utils.h>
#include "fo-property.h"
#include "fo-context.h"

G_BEGIN_DECLS

/* dominant-baseline */
/* auto | use-script | no-change | reset-size | ideographic | alphabetic | hanging | mathematical | central | middle | text-after-edge | text-before-edge | inherit */
/* Initial value: auto */
typedef enum {
  FO_ENUM_DOMINANT_BASELINE_AUTO,
  FO_ENUM_DOMINANT_BASELINE_USE_SCRIPT,
  FO_ENUM_DOMINANT_BASELINE_NO_CHANGE,
  FO_ENUM_DOMINANT_BASELINE_RESET_SIZE,
  FO_ENUM_DOMINANT_BASELINE_IDEOGRAPHIC,
  FO_ENUM_DOMINANT_BASELINE_ALPHABETIC,
  FO_ENUM_DOMINANT_BASELINE_HANGING,
  FO_ENUM_DOMINANT_BASELINE_MATHEMATICAL,
  FO_ENUM_DOMINANT_BASELINE_CENTRAL,
  FO_ENUM_DOMINANT_BASELINE_MIDDLE,
  FO_ENUM_DOMINANT_BASELINE_TEXT_AFTER_EDGE,
  FO_ENUM_DOMINANT_BASELINE_TEXT_BEFORE_EDGE
} FoEnumDominantBaseline;

GType fo_enum_dominant_baseline_get_type (void);
#define FO_TYPE_ENUM_DOMINANT_BASELINE fo_enum_dominant_baseline_get_type ()

#define FO_TYPE_PROPERTY_DOMINANT_BASELINE              (fo_property_dominant_baseline_get_type ())
#define FO_PROPERTY_DOMINANT_BASELINE(object)           (G_TYPE_CHECK_INSTANCE_CAST ((object), FO_TYPE_PROPERTY_DOMINANT_BASELINE, FoPropertyDominantBaseline))
#define FO_PROPERTY_DOMINANT_BASELINE_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST ((klass), FO_TYPE_PROPERTY_DOMINANT_BASELINE, FoPropertyDominantBaselineClass))
#define FO_IS_PROPERTY_DOMINANT_BASELINE(object)        (G_TYPE_CHECK_INSTANCE_TYPE ((object), FO_TYPE_PROPERTY_DOMINANT_BASELINE))
#define FO_IS_PROPERTY_DOMINANT_BASELINE_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), FO_TYPE_PROPERTY_DOMINANT_BASELINE))
#define FO_PROPERTY_DOMINANT_BASELINE_GET_CLASS(obj)    (G_TYPE_INSTANCE_GET_CLASS ((obj), FO_TYPE_PROPERTY_DOMINANT_BASELINE, FoPropertyDominantBaselineClass))


typedef struct _FoPropertyDominantBaseline      FoPropertyDominantBaseline;
typedef struct _FoPropertyDominantBaselineClass FoPropertyDominantBaselineClass;

GType       fo_property_dominant_baseline_get_type    (void) G_GNUC_CONST;
FoProperty* fo_property_dominant_baseline_new         (void);
FoProperty* fo_property_dominant_baseline_get_initial (void);
void fo_property_dominant_baseline_resolve (FoContext *current_context,
					    FoContext *parent_context);
G_END_DECLS

#endif /* !__FO_PROPERTY_DOMINANT_BASELINE_H__ */
