/* Fo
 * fo-property-inline-progression-dimension-maximum.c: 'inline-progression-dimension-maximum' property
 *
 * Copyright (C) 2001 Sun Microsystems
 *
 * $Id: fo-property-inline-progression-dimension-maximum.c,v 1.3 2003/07/02 10:39:38 tonygraham Exp $
 *
 * See Copying for the status of this software.
 */

#include <string.h>
#include "libfo/fo-utils.h"
#include "fo-context.h"
#include "datatype/fo-datatype.h"
#include "property/fo-property-private.h"
#include "property/fo-property-font-size.h"
#include "property/fo-property-inline-progression-dimension-maximum.h"

/* Inherited: FALSE */
/* Shorthand: FALSE */
/* inline-progression-dimension-maximum */
/* auto | <length> | <percentage> | <length-range> | inherit */
GType
fo_enum_inline_progression_dimension_maximum_get_type (void)
{
  static GType etype = 0;
  if (etype == 0)
    {
      static const GEnumValue values[] = {
        { FO_ENUM_INLINE_PROGRESSION_DIMENSION_MAXIMUM_AUTO, "FO_ENUM_INLINE_PROGRESSION_DIMENSION_MAXIMUM_AUTO", "auto" },
        { 0, NULL, NULL }
      };
      etype = g_enum_register_static ("FoEnumInlineProgressionDimensionMaximum", values);
    }
  return etype;
}

struct _FoPropertyInlineProgressionDimensionMaximum
{
  FoProperty parent_instance;
};

struct _FoPropertyInlineProgressionDimensionMaximumClass
{
  FoPropertyClass parent_class;
};

static void fo_property_inline_progression_dimension_maximum_init         (FoPropertyInlineProgressionDimensionMaximum      *property_inline_progression_dimension_maximum);
static void fo_property_inline_progression_dimension_maximum_base_init   (FoPropertyInlineProgressionDimensionMaximumClass *klass);
static void fo_property_inline_progression_dimension_maximum_base_finalize   (FoPropertyInlineProgressionDimensionMaximumClass *klass);
static void fo_property_inline_progression_dimension_maximum_class_init   (FoPropertyInlineProgressionDimensionMaximumClass *klass);
static void fo_property_inline_progression_dimension_maximum_finalize     (GObject       *object);

static FoDatatype* fo_property_inline_progression_dimension_maximum_resolve_enum (const gchar *token,
                                                                                  FoContext   *context,
                                                                                  GError     **error);
static FoDatatype* fo_property_inline_progression_dimension_maximum_validate (FoDatatype *datatype,
                                                                              FoContext  *context,
                                                                              GError    **error);

static const gchar class_name[] = "inline-progression-dimension-maximum";
static gpointer parent_class;
static FoDatatype *enum_auto;

/**
 * fo_property_inline_progression_dimension_maximum_get_type:
 * 
 * Register the #FoPropertyInlineProgressionDimensionMaximum type if not already registered and
 * return its #GType value.
 * 
 * Return value: #GType of #FoPropertyInlineProgressionDimensionMaximum.
 **/
GType
fo_property_inline_progression_dimension_maximum_get_type (void)
{
  static GType object_type = 0;

  if (!object_type)
    {
      static const GTypeInfo object_info =
      {
        sizeof (FoPropertyInlineProgressionDimensionMaximumClass),
        (GBaseInitFunc) fo_property_inline_progression_dimension_maximum_base_init,
        (GBaseFinalizeFunc) fo_property_inline_progression_dimension_maximum_base_finalize,
        (GClassInitFunc) fo_property_inline_progression_dimension_maximum_class_init,
        NULL,           /* class_finalize */
        NULL,           /* class_data */
        sizeof (FoPropertyInlineProgressionDimensionMaximum),
        0,              /* n_preallocs */
        (GInstanceInitFunc) fo_property_inline_progression_dimension_maximum_init,
	NULL		/* value_table */
      };

      object_type = g_type_register_static (FO_TYPE_PROPERTY,
                                            class_name,
                                            &object_info, 0);
    }

  return object_type;
}

/**
 * fo_property_inline_progression_dimension_maximum_init:
 * @inline_progression_dimension_maximum: #FoPropertyInlineProgressionDimensionMaximum object to initialise.
 * 
 * Implements #GInstanceInitFunc for #FoPropertyInlineProgressionDimensionMaximum.
 **/
void
fo_property_inline_progression_dimension_maximum_init (FoPropertyInlineProgressionDimensionMaximum *inline_progression_dimension_maximum)
{
  FO_PROPERTY (inline_progression_dimension_maximum)->value =
    g_object_ref (enum_auto);
}

/**
 * fo_property_inline_progression_dimension_maximum_base_init:
 * @klass: #FoPropertyInlineProgressionDimensionMaximumClass object to initialise.
 * 
 * Implements #GBaseInitFunc for #FoPropertyInlineProgressionDimensionMaximumClass.
 **/
void
fo_property_inline_progression_dimension_maximum_base_init (FoPropertyInlineProgressionDimensionMaximumClass *klass)
{
  enum_auto =
    g_object_new (FO_TYPE_ENUM,
                  "enum-class",
                  g_type_class_ref (FO_TYPE_ENUM_INLINE_PROGRESSION_DIMENSION_MAXIMUM),
                  "value",
                  FO_ENUM_INLINE_PROGRESSION_DIMENSION_MAXIMUM_AUTO,
                  NULL);
}

/**
 * fo_property_inline_progression_dimension_maximum_base_finalize:
 * @klass: #FoPropertyInlineProgressionDimensionMaximumClass object to finalise.
 * 
 * Implements #GBaseFinalizeFunc for #FoPropertyInlineProgressionDimensionMaximumClass.
 **/
void
fo_property_inline_progression_dimension_maximum_base_finalize (FoPropertyInlineProgressionDimensionMaximumClass *klass)
{
  g_object_unref (enum_auto);
}

/**
 * fo_property_inline_progression_dimension_maximum_class_init:
 * @klass: #FoPropertyInlineProgressionDimensionMaximumClass object to initialise.
 * 
 * Implements #GClassInitFunc for #FoPropertyInlineProgressionDimensionMaximumClass.
 **/
void
fo_property_inline_progression_dimension_maximum_class_init (FoPropertyInlineProgressionDimensionMaximumClass *klass)
{
  GObjectClass *object_class = G_OBJECT_CLASS (klass);
  FoPropertyClass *property_class = FO_PROPERTY_CLASS (klass);

  parent_class = g_type_class_peek_parent (klass);

  object_class->finalize = fo_property_inline_progression_dimension_maximum_finalize;

  property_class->is_inherited = FALSE;
  property_class->is_shorthand = FALSE;
  property_class->resolve_enum =
    fo_property_inline_progression_dimension_maximum_resolve_enum;
  property_class->validate =
    fo_property_inline_progression_dimension_maximum_validate;
  property_class->get_initial =
    fo_property_inline_progression_dimension_maximum_get_initial;
}

/**
 * fo_property_inline_progression_dimension_maximum_finalize:
 * @object: #FoPropertyInlineProgressionDimensionMaximum object to finalize.
 * 
 * Implements #GObjectFinalizeFunc for #FoPropertyInlineProgressionDimensionMaximum.
 **/
void
fo_property_inline_progression_dimension_maximum_finalize (GObject *object)
{
  FoPropertyInlineProgressionDimensionMaximum *inline_progression_dimension_maximum;

  inline_progression_dimension_maximum = FO_PROPERTY_INLINE_PROGRESSION_DIMENSION_MAXIMUM (object);

  G_OBJECT_CLASS (parent_class)->finalize (object);
}


/**
 * fo_property_inline_progression_dimension_maximum_new:
 * 
 * Creates a new #FoPropertyInlineProgressionDimensionMaximum initialized to default value.
 * 
 * Return value: the new #FoPropertyInlineProgressionDimensionMaximum.
 **/
FoProperty*
fo_property_inline_progression_dimension_maximum_new (void)
{
  FoProperty* inline_progression_dimension_maximum;

  inline_progression_dimension_maximum =
    FO_PROPERTY (g_object_new (fo_property_inline_progression_dimension_maximum_get_type (),
                               NULL));

  return inline_progression_dimension_maximum;
}

/**
 * fo_property_inline_progression_dimension_maximum_resolve_enum:
 * @token:   Token from the XML attribute value to be evaluated as an
 *           enumeration token.
 * @context: #FoContext object from which to possibly inherit values.
 * @error:   Information about any error that has occurred.
 * 
 * Compare @token against the enumeration tokens that are valid for the
 * current FO property.  If @token is valid, returns either an #FoEnum datatype
 * representing the enumeration token or a different datatype representing
 * the enumeration token's resolved value.  If @token is not valid,
 * sets @error and returns NULL.
 * 
 * Return value: Resolved enumeration value or NULL.
 **/
FoDatatype*
fo_property_inline_progression_dimension_maximum_resolve_enum (const gchar *token,
                                                               FoContext   *context,
                                                               GError     **error)
{
  g_return_val_if_fail (token != NULL, NULL);
  g_return_val_if_fail (FO_IS_CONTEXT (context), NULL);
  g_return_val_if_fail (error == NULL || *error == NULL, NULL);

  if (strcmp (token, "auto") == 0)
    {
      return g_object_ref (enum_auto);
    }
  else
    {
      g_set_error (error,
		   FO_FO_ERROR,
		   FO_FO_ERROR_ENUMERATION_TOKEN,
		   _(fo_fo_error_messages[FO_FO_ERROR_ENUMERATION_TOKEN]),
		   class_name,
		   token);
      return NULL;
    }
}

/**
 * fo_property_inline_progression_dimension_maximum_validate:
 * @datatype: #FoDatatype to be validated against allowed datatypes and
 *            values for current property.
 * @context:  #FoContext object from which to possibly inherit values.
 * @error:    Information about any error that has occurred.
 * 
 * Validates @datatype against allowed values.  Returns @datatype, a
 * replacement datatype value, or NULL if validation failed.
 * 
 * Return value: Valid datatype value or NULL.
 **/
FoDatatype*
fo_property_inline_progression_dimension_maximum_validate (FoDatatype *datatype,
                                                           FoContext  *context,
                                                           GError    **error)
{
  FoDatatype *new_datatype;
  GError     *tmp_error = NULL;
  gchar      *token;

  g_return_val_if_fail (datatype != NULL, NULL);
  g_return_val_if_fail (FO_IS_DATATYPE (datatype), NULL);
  g_return_val_if_fail (context != NULL, NULL);
  g_return_val_if_fail (FO_IS_CONTEXT (context), NULL);
  g_return_val_if_fail (error == NULL || *error == NULL, NULL);

  if (FO_IS_ENUM (datatype))
    {
      if ((G_ENUM_CLASS_TYPE (fo_enum_get_enum_class (datatype))
           == FO_TYPE_ENUM_INLINE_PROGRESSION_DIMENSION_MAXIMUM) &&
	  (g_enum_get_value (fo_enum_get_enum_class (datatype),
			     fo_enum_get_value (datatype)) != NULL))
	{
	  return datatype;
	}
      else
	{
	  gchar *datatype_sprintf = fo_object_sprintf (datatype);

	  g_set_error (error,
		       FO_FO_ERROR,
		       FO_FO_ERROR_DATATYPE,
		       _(fo_fo_error_messages[FO_FO_ERROR_DATATYPE]),
		       class_name,
		       datatype_sprintf,
		       g_type_name (G_TYPE_FROM_INSTANCE (datatype)));

	  g_object_unref (datatype);

	  g_free (datatype_sprintf);

	  return NULL;
	}
    }
  else if (FO_IS_STRING (datatype))
    {
      token = fo_string_get_value (datatype);

      new_datatype =
        fo_property_inline_progression_dimension_maximum_resolve_enum (token, context, &tmp_error);

      g_object_unref (datatype);

      if (tmp_error != NULL)
	{
	  g_propagate_error (error, tmp_error);
	  return NULL;
	}

      return new_datatype;
    }
  else if (FO_IS_NAME (datatype))
    {
      token = fo_name_get_value (datatype);

      new_datatype =
        fo_property_inline_progression_dimension_maximum_resolve_enum (token, context, &tmp_error);

      g_object_unref (datatype);

      if (tmp_error != NULL)
	{
	  g_propagate_error (error, tmp_error);
	  return NULL;
	}

      return new_datatype;
    }
  else if (FO_IS_LENGTH (datatype))
    {
      return datatype;
    }
  else if (FO_IS_PERCENTAGE (datatype))
    {
      return datatype;
    }
  else if (FO_IS_LENGTH_RANGE (datatype))
    {
      return datatype;
    }
  else
    {
      gchar *datatype_sprintf = fo_object_sprintf (datatype);

      g_set_error (error,
		   FO_FO_ERROR,
		   FO_FO_ERROR_DATATYPE,
		   _(fo_fo_error_messages[FO_FO_ERROR_DATATYPE]),
		   class_name,
		   datatype_sprintf,
		   g_type_name (G_TYPE_FROM_INSTANCE (datatype)));

      g_object_unref (datatype);

      g_free (datatype_sprintf);

      return NULL;
    }
}

/**
 * fo_property_inline_progression_dimension_maximum_get_initial:
 * 
 * Get an instance of the property with the correct initial value.
 * 
 * Return value: An instance of the property.
 **/
FoProperty*
fo_property_inline_progression_dimension_maximum_get_initial (void)
{
  static FoProperty *inline_progression_dimension_maximum = NULL;

  if (inline_progression_dimension_maximum == NULL)
    {
      inline_progression_dimension_maximum = fo_property_inline_progression_dimension_maximum_new ();
    }

  return inline_progression_dimension_maximum;
}
