/* Fo
 * fo-property-margin-right.h: margin-right property
 *
 * Copyright (C) 2001 Sun Microsystems
 *
 * $Id: fo-property-margin-right.h,v 1.2 2003/03/21 14:41:38 tonygraham Exp $
 *
 * See Copyright for the status of this software.
 */
#ifndef __FO_PROPERTY_MARGIN_RIGHT_H__
#define __FO_PROPERTY_MARGIN_RIGHT_H__

#include <libfo/fo-utils.h>

G_BEGIN_DECLS

/* margin-right */
/* <margin-width> | inherit */
typedef enum {
  FO_ENUM_MARGIN_RIGHT_AUTO,
  FO_ENUM_MARGIN_RIGHT_INHERIT
} FoEnumMarginRight;

GType fo_enum_margin_right_get_type (void);
#define FO_TYPE_ENUM_MARGIN_RIGHT fo_enum_margin_right_get_type ()

#define FO_TYPE_PROPERTY_MARGIN_RIGHT              (fo_property_margin_right_get_type ())
#define FO_PROPERTY_MARGIN_RIGHT(object)           (G_TYPE_CHECK_INSTANCE_CAST ((object), FO_TYPE_PROPERTY_MARGIN_RIGHT, FoPropertyMarginRight))
#define FO_PROPERTY_MARGIN_RIGHT_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST ((klass), FO_TYPE_PROPERTY_MARGIN_RIGHT, FoPropertyMarginRightClass))
#define FO_IS_PROPERTY_MARGIN_RIGHT(object)        (G_TYPE_CHECK_INSTANCE_TYPE ((object), FO_TYPE_PROPERTY_MARGIN_RIGHT))
#define FO_IS_PROPERTY_MARGIN_RIGHT_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), FO_TYPE_PROPERTY_MARGIN_RIGHT))
#define FO_PROPERTY_MARGIN_RIGHT_GET_CLASS(obj)    (G_TYPE_INSTANCE_GET_CLASS ((obj), FO_TYPE_PROPERTY_MARGIN_RIGHT, FoPropertyMarginRightClass))


typedef struct _FoPropertyMarginRight      FoPropertyMarginRight;
typedef struct _FoPropertyMarginRightClass FoPropertyMarginRightClass;

GType       fo_property_margin_right_get_type      (void) G_GNUC_CONST;
FoProperty* fo_property_margin_right_new           (void);

void fo_property_margin_right_set_value (FoProperty *property,
		      FoDatatype *new_value);
FoDatatype* fo_property_margin_right_get_value (FoProperty *property);
FoProperty* fo_property_margin_right_new_from_expression (const gchar *expression,
						    FoContext   *context,
						    FoProperty    *current_font_size,
							 FoFo *fo_node,
                                            GError    **error);
FoProperty* fo_property_margin_right_get_initial (void);

G_END_DECLS

#endif /* !__FO_PROPERTY_MARGIN_RIGHT_H__ */
