/* Fo
 * fo-property-margin.h: margin property
 *
 * Copyright (C) 2001 Sun Microsystems
 *
 * $Id: fo-property-margin.h,v 1.3 2003/03/21 14:41:38 tonygraham Exp $
 *
 * See Copying for the status of this software.
 */

#ifndef __FO_PROPERTY_MARGIN_H__
#define __FO_PROPERTY_MARGIN_H__

#include <libfo/fo-utils.h>

G_BEGIN_DECLS

/* margin */
/* <margin-width>{1,4} | inherit */
typedef enum {
  FO_ENUM_MARGIN_AUTO
} FoEnumMargin;

GType fo_enum_margin_get_type (void);
#define FO_TYPE_ENUM_MARGIN fo_enum_margin_get_type ()

#define FO_TYPE_PROPERTY_MARGIN              (fo_property_margin_get_type ())
#define FO_PROPERTY_MARGIN(object)           (G_TYPE_CHECK_INSTANCE_CAST ((object), FO_TYPE_PROPERTY_MARGIN, FoPropertyMargin))
#define FO_PROPERTY_MARGIN_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST ((klass), FO_TYPE_PROPERTY_MARGIN, FoPropertyMarginClass))
#define FO_IS_PROPERTY_MARGIN(object)        (G_TYPE_CHECK_INSTANCE_TYPE ((object), FO_TYPE_PROPERTY_MARGIN))
#define FO_IS_PROPERTY_MARGIN_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), FO_TYPE_PROPERTY_MARGIN))
#define FO_PROPERTY_MARGIN_GET_CLASS(obj)    (G_TYPE_INSTANCE_GET_CLASS ((obj), FO_TYPE_PROPERTY_MARGIN, FoPropertyMarginClass))


typedef struct _FoPropertyMargin      FoPropertyMargin;
typedef struct _FoPropertyMarginClass FoPropertyMarginClass;

GType       fo_property_margin_get_type      (void) G_GNUC_CONST;
FoProperty* fo_property_margin_new           (void);

FoProperty* fo_property_margin_new_from_expression (const gchar *expression,
						    FoContext   *context,
						    FoProperty    *current_font_size,
							 FoFo *fo_node,
                                            GError    **error);
FoProperty* fo_property_margin_get_initial (void);
void fo_property_margin_resolve (FoContext *current_context,
				 FoContext *parent_context);

G_END_DECLS

#endif /* !__FO_PROPERTY_MARGIN_H__ */
