/* Fo
 * fo-property-overflow.h: 'overflow' property
 *
 * Copyright (C) 2001 Sun Microsystems
 *
 * $Id: fo-property-overflow.h,v 1.2 2003/03/21 14:41:39 tonygraham Exp $
 *
 * See Copying for the status of this software.
 */

#ifndef __FO_PROPERTY_OVERFLOW_H__
#define __FO_PROPERTY_OVERFLOW_H__

#include <libfo/fo-utils.h>
#include "fo-context.h"

G_BEGIN_DECLS

/* overflow */
/* visible | hidden | scroll | error-if-overflow | auto | inherit */
typedef enum {
  FO_ENUM_OVERFLOW_VISIBLE,
  FO_ENUM_OVERFLOW_HIDDEN,
  FO_ENUM_OVERFLOW_SCROLL,
  FO_ENUM_OVERFLOW_ERROR_IF_OVERFLOW,
  FO_ENUM_OVERFLOW_AUTO,
  FO_ENUM_OVERFLOW_INHERIT
} FoEnumOverflow;

GType fo_enum_overflow_get_type (void);
#define FO_TYPE_ENUM_OVERFLOW fo_enum_overflow_get_type ()

#define FO_TYPE_PROPERTY_OVERFLOW              (fo_property_overflow_get_type ())
#define FO_PROPERTY_OVERFLOW(object)           (G_TYPE_CHECK_INSTANCE_CAST ((object), FO_TYPE_PROPERTY_OVERFLOW, FoPropertyOverflow))
#define FO_PROPERTY_OVERFLOW_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST ((klass), FO_TYPE_PROPERTY_OVERFLOW, FoPropertyOverflowClass))
#define FO_IS_PROPERTY_OVERFLOW(object)        (G_TYPE_CHECK_INSTANCE_TYPE ((object), FO_TYPE_PROPERTY_OVERFLOW))
#define FO_IS_PROPERTY_OVERFLOW_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), FO_TYPE_PROPERTY_OVERFLOW))
#define FO_PROPERTY_OVERFLOW_GET_CLASS(obj)    (G_TYPE_INSTANCE_GET_CLASS ((obj), FO_TYPE_PROPERTY_OVERFLOW, FoPropertyOverflowClass))


typedef struct _FoPropertyOverflow      FoPropertyOverflow;
typedef struct _FoPropertyOverflowClass FoPropertyOverflowClass;

GType       fo_property_overflow_get_type      (void) G_GNUC_CONST;
FoProperty* fo_property_overflow_new           (void);

void fo_property_overflow_set_value (FoProperty *property,
                                     FoDatatype *new_value);
FoDatatype* fo_property_overflow_get_value (FoProperty *property);
FoProperty* fo_property_overflow_new_from_expression (const gchar *expression,
                                                      FoContext   *context,
                                                      FoProperty  *current_font_size,
                                                      FoFo        *fo_node,
                                                      GError     **error);
FoProperty* fo_property_overflow_get_initial (void);

G_END_DECLS

#endif /* !__FO_PROPERTY_OVERFLOW_H__ */
