/* Fo
 * fo-property-page-width.h: page-width property
 *
 * Copyright (C) 2001 Sun Microsystems
 *
 * $Id: fo-property-page-width.h,v 1.2 2003/03/21 14:41:39 tonygraham Exp $
 *
 * See Copyright for the status of this software.
 */
#ifndef __FO_PROPERTY_PAGE_WIDTH_H__
#define __FO_PROPERTY_PAGE_WIDTH_H__

#include <libfo/fo-utils.h>

G_BEGIN_DECLS

/* page-width */
/* auto | indefinite | <length> | inherit */
typedef enum {
  FO_ENUM_PAGE_WIDTH_AUTO,
  FO_ENUM_PAGE_WIDTH_INDEFINITE,
  FO_ENUM_PAGE_WIDTH_INHERIT
} FoEnumPageWidth;

GType fo_enum_page_width_get_type (void);
#define FO_TYPE_ENUM_PAGE_WIDTH fo_enum_page_width_get_type ()

#define FO_TYPE_PROPERTY_PAGE_WIDTH              (fo_property_page_width_get_type ())
#define FO_PROPERTY_PAGE_WIDTH(object)           (G_TYPE_CHECK_INSTANCE_CAST ((object), FO_TYPE_PROPERTY_PAGE_WIDTH, FoPropertyPageWidth))
#define FO_PROPERTY_PAGE_WIDTH_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST ((klass), FO_TYPE_PROPERTY_PAGE_WIDTH, FoPropertyPageWidthClass))
#define FO_IS_PROPERTY_PAGE_WIDTH(object)        (G_TYPE_CHECK_INSTANCE_TYPE ((object), FO_TYPE_PROPERTY_PAGE_WIDTH))
#define FO_IS_PROPERTY_PAGE_WIDTH_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), FO_TYPE_PROPERTY_PAGE_WIDTH))
#define FO_PROPERTY_PAGE_WIDTH_GET_CLASS(obj)    (G_TYPE_INSTANCE_GET_CLASS ((obj), FO_TYPE_PROPERTY_PAGE_WIDTH, FoPropertyPageWidthClass))


typedef struct _FoPropertyPageWidth      FoPropertyPageWidth;
typedef struct _FoPropertyPageWidthClass FoPropertyPageWidthClass;

GType       fo_property_page_width_get_type      (void) G_GNUC_CONST;
FoProperty* fo_property_page_width_new           (void);

void fo_property_page_width_set_value (FoProperty *property,
		      FoDatatype *new_value);
FoDatatype* fo_property_page_width_get_value (FoProperty *property);
FoProperty* fo_property_page_width_new_from_expression (const gchar *expression,
						    FoContext   *context,
						    FoProperty    *current_font_size,
							 FoFo *fo_node,
                                            GError    **error);
FoProperty* fo_property_page_width_get_initial (void);

G_END_DECLS

#endif /* !__FO_PROPERTY_PAGE_WIDTH_H__ */
