/* Fo
 * fo-property-region-name.c: region-name property
 *
 * Copyright (C) 2001 Sun Microsystems
 *
 * $Id: fo-property-region-name.c,v 1.2 2003/03/21 14:41:39 tonygraham Exp $
 *
 * See Copyright for the status of this software.
 */

#include <string.h>
#include "libfo/fo-utils.h"
#include "fo-datatype.h"
#include "fo-property-private.h"
#include "fo-property-font-size.h"
#include <fo-property-region-name.h>

/* region-name */
/* xsl-region-body | xsl-region-start | xsl-region-end | xsl-region-before | xsl-region-after | xsl-before-float-separator | xsl-footnote-separator | <name> */
GType
fo_enum_region_name_get_type (void)
{
  static GType etype = 0;
  if (etype == 0)
    {
      static const GEnumValue values[] = {
        { FO_ENUM_REGION_NAME_XSL_REGION_BODY, "FO_ENUM_REGION_NAME_XSL_REGION_BODY", "xsl-region-body" },
        { FO_ENUM_REGION_NAME_XSL_REGION_START, "FO_ENUM_REGION_NAME_XSL_REGION_START", "xsl-region-start" },
        { FO_ENUM_REGION_NAME_XSL_REGION_END, "FO_ENUM_REGION_NAME_XSL_REGION_END", "xsl-region-end" },
        { FO_ENUM_REGION_NAME_XSL_REGION_BEFORE, "FO_ENUM_REGION_NAME_XSL_REGION_BEFORE", "xsl-region-before" },
        { FO_ENUM_REGION_NAME_XSL_REGION_AFTER, "FO_ENUM_REGION_NAME_XSL_REGION_AFTER", "xsl-region-after" },
        { FO_ENUM_REGION_NAME_XSL_BEFORE_FLOAT_SEPARATOR, "FO_ENUM_REGION_NAME_XSL_BEFORE_FLOAT_SEPARATOR", "xsl-before-float-separator" },
        { FO_ENUM_REGION_NAME_XSL_FOOTNOTE_SEPARATOR, "FO_ENUM_REGION_NAME_XSL_FOOTNOTE_SEPARATOR", "xsl-footnote-separator" },
        { 0, NULL, NULL }
      };
      etype = g_enum_register_static ("FoEnumRegionName", values);
    }
  return etype;
}

enum {
  PROP_0,
  PROP_VALUE
};

struct _FoPropertyRegionName
{
  FoProperty parent_instance;

  FoDatatype *value;
};

struct _FoPropertyRegionNameClass
{
  FoPropertyClass parent_class;
  
};

static void fo_property_region_name_init         (FoPropertyRegionName      *property_region_name);
static void fo_property_region_name_base_class_init   (FoPropertyRegionNameClass *klass);
static void fo_property_region_name_base_class_finalize   (FoPropertyRegionNameClass *klass);
static void fo_property_region_name_class_init   (FoPropertyRegionNameClass *klass);
static void fo_property_region_name_set_property (GObject       *object,
				    guint          prop_id,
				    const GValue  *value,
				    GParamSpec    *pspec);
static void fo_property_region_name_get_property (GObject       *object,
				    guint          prop_id,
				    GValue        *value,
				    GParamSpec    *pspec);
static void fo_property_region_name_finalize     (GObject       *object);

FoDatatype* fo_property_region_name_copy(FoDatatype *datatype);
static FoDatatype* fo_property_region_name_resolve_enum (const gchar *token,
							 FoContext *context, GError **err);
static FoDatatype* fo_property_region_name_validate (FoDatatype *datatype,
						     FoContext *context);
static gchar*      fo_property_region_name_sprintf (FoObject *object);

static gpointer parent_class;
static FoDatatype *enum_xsl_region_body;
static FoDatatype *enum_xsl_region_start;
static FoDatatype *enum_xsl_region_end;
static FoDatatype *enum_xsl_region_before;
static FoDatatype *enum_xsl_region_after;
static FoDatatype *enum_xsl_before_float_separator;
static FoDatatype *enum_xsl_footnote_separator;

GType
fo_property_region_name_get_type (void)
{
  static GType object_type = 0;

  if (!object_type)
    {
      static const GTypeInfo object_info =
      {
        sizeof (FoPropertyRegionNameClass),
        (GBaseInitFunc) fo_property_region_name_base_class_init,
        (GBaseFinalizeFunc) fo_property_region_name_base_class_finalize,
        (GClassInitFunc) fo_property_region_name_class_init,
        NULL,           /* class_finalize */
        NULL,           /* class_data */
        sizeof (FoPropertyRegionName),
        0,              /* n_preallocs */
        (GInstanceInitFunc) fo_property_region_name_init,
      };
      
      object_type = g_type_register_static (FO_TYPE_PROPERTY,
                                            "FoPropertyRegionName",
                                            &object_info, 0);
    }
  
  return object_type;
}

static void
fo_property_region_name_init (FoPropertyRegionName *region_name)
{
  region_name->value = NULL;
}

static void
fo_property_region_name_base_class_init (FoPropertyRegionNameClass *klass)
{
  enum_xsl_region_body =
    g_object_new (FO_TYPE_ENUM,
                  "enum-class",
                  g_type_class_ref (FO_TYPE_ENUM_REGION_NAME),
                  "value",
                  FO_ENUM_REGION_NAME_XSL_REGION_BODY,
                  NULL);
  enum_xsl_region_start =
    g_object_new (FO_TYPE_ENUM,
                  "enum-class",
                  g_type_class_ref (FO_TYPE_ENUM_REGION_NAME),
                  "value",
                  FO_ENUM_REGION_NAME_XSL_REGION_START,
                  NULL);
  enum_xsl_region_end =
    g_object_new (FO_TYPE_ENUM,
                  "enum-class",
                  g_type_class_ref (FO_TYPE_ENUM_REGION_NAME),
                  "value",
                  FO_ENUM_REGION_NAME_XSL_REGION_END,
                  NULL);
  enum_xsl_region_before =
    g_object_new (FO_TYPE_ENUM,
                  "enum-class",
                  g_type_class_ref (FO_TYPE_ENUM_REGION_NAME),
                  "value",
                  FO_ENUM_REGION_NAME_XSL_REGION_BEFORE,
                  NULL);
  enum_xsl_region_after =
    g_object_new (FO_TYPE_ENUM,
                  "enum-class",
                  g_type_class_ref (FO_TYPE_ENUM_REGION_NAME),
                  "value",
                  FO_ENUM_REGION_NAME_XSL_REGION_AFTER,
                  NULL);
  enum_xsl_before_float_separator =
    g_object_new (FO_TYPE_ENUM,
                  "enum-class",
                  g_type_class_ref (FO_TYPE_ENUM_REGION_NAME),
                  "value",
                  FO_ENUM_REGION_NAME_XSL_BEFORE_FLOAT_SEPARATOR,
                  NULL);
  enum_xsl_footnote_separator =
    g_object_new (FO_TYPE_ENUM,
                  "enum-class",
                  g_type_class_ref (FO_TYPE_ENUM_REGION_NAME),
                  "value",
                  FO_ENUM_REGION_NAME_XSL_FOOTNOTE_SEPARATOR,
                  NULL);
}

static void
fo_property_region_name_base_class_finalize (FoPropertyRegionNameClass *klass)
{  g_object_unref (enum_xsl_region_body);
  g_object_unref (enum_xsl_region_start);
  g_object_unref (enum_xsl_region_end);
  g_object_unref (enum_xsl_region_before);
  g_object_unref (enum_xsl_region_after);
  g_object_unref (enum_xsl_before_float_separator);
  g_object_unref (enum_xsl_footnote_separator);
}

static void
fo_property_region_name_class_init (FoPropertyRegionNameClass *klass)
{
  GObjectClass *object_class = G_OBJECT_CLASS (klass);
  
  parent_class = g_type_class_peek_parent (klass);
  
  object_class->finalize = fo_property_region_name_finalize;

  object_class->set_property = fo_property_region_name_set_property;
  object_class->get_property = fo_property_region_name_get_property;

  g_object_class_install_property (object_class,
                                   PROP_VALUE,
                                   g_param_spec_object ("value",
						     _("region-name value"),
						     _("region-name property value"),
							FO_TYPE_DATATYPE,
						     G_PARAM_READWRITE));

  FO_PROPERTY_CLASS(klass)->is_inherited = FALSE;
  FO_PROPERTY_CLASS(klass)->new_from_expression =
    fo_property_region_name_new_from_expression;
  FO_OBJECT_CLASS(klass)->sprintf =
    fo_property_region_name_sprintf;
  FO_PROPERTY_CLASS(klass)->set_value =
    fo_property_region_name_set_value;
  FO_PROPERTY_CLASS(klass)->get_value =
    fo_property_region_name_get_value;
}

static void
fo_property_region_name_finalize (GObject *object)
{
  FoPropertyRegionName *region_name;

  region_name = FO_PROPERTY_REGION_NAME (object);

  G_OBJECT_CLASS (parent_class)->finalize (object);
}


static void
fo_property_region_name_set_property (GObject         *object,
                         guint            prop_id,
                         const GValue    *value,
                         GParamSpec      *pspec)
{
  FoPropertyRegionName *region_name;

  region_name = FO_PROPERTY_REGION_NAME (object);

  switch (prop_id)
    {
    case PROP_VALUE:
      fo_property_region_name_set_value (FO_PROPERTY (region_name), g_value_get_object (value));
      break;
    default:
      G_OBJECT_WARN_INVALID_PROPERTY_ID (object, prop_id, pspec);
      break;
    }
}

static void
fo_property_region_name_get_property (GObject         *object,
                         guint            prop_id,
                         GValue          *value,
                         GParamSpec      *pspec)
{
  FoPropertyRegionName *region_name;

  region_name = FO_PROPERTY_REGION_NAME (object);

  switch (prop_id)
    {
    case PROP_VALUE:
      g_value_set_instance (value,
			  fo_property_region_name_get_value (FO_PROPERTY (region_name)));
      break;
    default:
      G_OBJECT_WARN_INVALID_PROPERTY_ID (object, prop_id, pspec);
      break;
    }
}

/**
 * fo_property_region_name_new:
 * 
 * Creates a new #FoPropertyRegionName initialized to default value.
 * 
 * Return value: the new #FoPropertyRegionName
 **/
FoProperty*
fo_property_region_name_new (void)
{
  FoProperty* region_name;

  region_name =
    FO_PROPERTY (g_object_new (fo_property_region_name_get_type (), NULL));
  
  return region_name;
}

FoDatatype*
fo_property_region_name_resolve_enum (const gchar *token, FoContext *context, GError **err)
{
  g_return_val_if_fail (token != NULL, NULL);

  if (strcmp (token, "xsl-region-body") == 0)
    {
      return g_object_ref (enum_xsl_region_body);
    }
  else if (strcmp (token, "xsl-region-start") == 0)
    {
      return g_object_ref (enum_xsl_region_start);
    }
  else if (strcmp (token, "xsl-region-end") == 0)
    {
      return g_object_ref (enum_xsl_region_end);
    }
  else if (strcmp (token, "xsl-region-before") == 0)
    {
      return g_object_ref (enum_xsl_region_before);
    }
  else if (strcmp (token, "xsl-region-after") == 0)
    {
      return g_object_ref (enum_xsl_region_after);
    }
  else if (strcmp (token, "xsl-before-float-separator") == 0)
    {
      return g_object_ref (enum_xsl_before_float_separator);
    }
  else if (strcmp (token, "xsl-footnote-separator") == 0)
    {
      return g_object_ref (enum_xsl_footnote_separator);
    }
  else
    {
      g_warning("Unrecognized region-name enumeration token: %s", token);
      return NULL;
    }
}

FoDatatype*
fo_property_region_name_validate (FoDatatype *datatype, FoContext *context)
{
  FoDatatype *new_datatype;
  gchar *token;

  g_return_val_if_fail (datatype != NULL, NULL);
  g_return_val_if_fail (FO_IS_DATATYPE (datatype), NULL);
  g_return_val_if_fail (context != NULL, NULL);
  g_return_val_if_fail (FO_IS_CONTEXT (context), NULL);

  if (FO_IS_NAME (datatype))
    {
      return datatype;
    }
  else
    {
      g_warning("Invalid region-name datatype: %s (%s)",
	        fo_object_sprintf (FO_OBJECT (datatype)),
		g_type_name(G_TYPE_FROM_INSTANCE (datatype)));

      g_object_unref (datatype);

      return NULL;
    }
}

FoProperty*
fo_property_region_name_new_from_expression (const gchar *expression,
					   FoContext *context,
					   FoProperty *current_font_size,
					   FoFo *fo_node,
					   GError **error)
{
  FoProperty *region_name;
  FoDatatype *datatype;

  g_return_val_if_fail (expression != NULL, NULL);
  g_return_val_if_fail (context != NULL, NULL);
  g_return_val_if_fail (FO_IS_CONTEXT (context), NULL);
  g_return_val_if_fail
    (current_font_size == NULL || FO_IS_PROPERTY_FONT_SIZE (current_font_size),
     NULL);

  region_name = fo_property_region_name_new ();

  datatype =
    fo_property_eval_expression (expression,
				 "region-name",
				 context,
				 NULL,
				 current_font_size,
				 fo_node);

  datatype = fo_property_region_name_validate (datatype, context);

  fo_property_region_name_set_value (region_name, datatype);

  return region_name;
}

/* value */
void
fo_property_region_name_set_value (FoProperty *property,
		       FoDatatype *new_value)
{
  FoPropertyRegionName *region_name;

  g_return_if_fail (property != NULL);

  region_name = FO_PROPERTY_REGION_NAME (property);

  region_name->value = new_value;
  /*g_object_notify(G_OBJECT(region_name), "value");*/
}

FoDatatype*
fo_property_region_name_get_value (FoProperty *property)
{
  FoPropertyRegionName *region_name;

  g_return_val_if_fail (property != NULL, NULL);

  region_name = FO_PROPERTY_REGION_NAME (property);

  return region_name->value;
}

gchar*
fo_property_region_name_sprintf (FoObject *object)
{
  FoPropertyRegionName *region_name;
  FoDatatype *datatype;

  g_return_val_if_fail (object != NULL, NULL);

  region_name = FO_PROPERTY_REGION_NAME (object);
  datatype = fo_property_region_name_get_value (region_name);

  return
    g_strdup_printf ("region-name: %s",
		     fo_object_sprintf (FO_OBJECT (datatype)));
}

FoProperty*
fo_property_region_name_get_initial (void)
{
  FoProperty *region_name;

  region_name = fo_property_region_name_new ();

  /* Set the initial value here */
  fo_property_region_name_set_value (region_name,
             NULL);

  return region_name;
}
