/* Fo
 * fo-property-scaling.h: 'scaling' property
 *
 * Copyright (C) 2001 Sun Microsystems
 *
 * $Id: fo-property-scaling.h,v 1.2 2003/03/21 14:41:40 tonygraham Exp $
 *
 * See Copying for the status of this software.
 */

#ifndef __FO_PROPERTY_SCALING_H__
#define __FO_PROPERTY_SCALING_H__

#include <libfo/fo-utils.h>
#include "fo-context.h"

G_BEGIN_DECLS

/* scaling */
/* uniform | non-uniform | inherit */
typedef enum {
  FO_ENUM_SCALING_UNIFORM,
  FO_ENUM_SCALING_NON_UNIFORM,
  FO_ENUM_SCALING_INHERIT
} FoEnumScaling;

GType fo_enum_scaling_get_type (void);
#define FO_TYPE_ENUM_SCALING fo_enum_scaling_get_type ()

#define FO_TYPE_PROPERTY_SCALING              (fo_property_scaling_get_type ())
#define FO_PROPERTY_SCALING(object)           (G_TYPE_CHECK_INSTANCE_CAST ((object), FO_TYPE_PROPERTY_SCALING, FoPropertyScaling))
#define FO_PROPERTY_SCALING_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST ((klass), FO_TYPE_PROPERTY_SCALING, FoPropertyScalingClass))
#define FO_IS_PROPERTY_SCALING(object)        (G_TYPE_CHECK_INSTANCE_TYPE ((object), FO_TYPE_PROPERTY_SCALING))
#define FO_IS_PROPERTY_SCALING_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), FO_TYPE_PROPERTY_SCALING))
#define FO_PROPERTY_SCALING_GET_CLASS(obj)    (G_TYPE_INSTANCE_GET_CLASS ((obj), FO_TYPE_PROPERTY_SCALING, FoPropertyScalingClass))


typedef struct _FoPropertyScaling      FoPropertyScaling;
typedef struct _FoPropertyScalingClass FoPropertyScalingClass;

GType       fo_property_scaling_get_type      (void) G_GNUC_CONST;
FoProperty* fo_property_scaling_new           (void);

void fo_property_scaling_set_value (FoProperty *property,
                                    FoDatatype *new_value);
FoDatatype* fo_property_scaling_get_value (FoProperty *property);
FoProperty* fo_property_scaling_new_from_expression (const gchar *expression,
                                                     FoContext   *context,
                                                     FoProperty  *current_font_size,
                                                     FoFo        *fo_node,
                                                     GError     **error);
FoProperty* fo_property_scaling_get_initial (void);

G_END_DECLS

#endif /* !__FO_PROPERTY_SCALING_H__ */
