/* Fo
 * fo-property-space-end-precedence.c: space-end.precedence property
 *
 * Copyright (C) 2001 Sun Microsystems
 *
 * $Id: fo-property-space-end-precedence.c,v 1.2 2003/03/21 14:41:44 tonygraham Exp $
 *
 * See Copyright for the status of this software.
 */

#include <string.h>
#include "libfo/fo-utils.h"
#include "fo-datatype.h"
#include "fo-length.h"
#include "fo-property-private.h"
#include "fo-property-font-size.h"
#include <fo-property-space-end-precedence.h>

/* space-end.precedence */
/* <integer> | force */
GType
fo_enum_space_end_precedence_get_type (void)
{
  static GType etype = 0;
  if (etype == 0)
    {
      static const GEnumValue values[] = {
        { FO_ENUM_SPACE_END_PRECEDENCE_FORCE, "FO_ENUM_SPACE_END_PRECEDENCE_FORCE", "force" },
        { 0, NULL, NULL }
      };
      etype = g_enum_register_static ("FoEnumSpaceEndPrecedence", values);
    }
  return etype;
}

enum {
  PROP_0,
  PROP_VALUE
};

struct _FoPropertySpaceEndPrecedence
{
  FoProperty parent_instance;

  FoDatatype *value;
};

struct _FoPropertySpaceEndPrecedenceClass
{
  FoPropertyClass parent_class;
  
};

static void fo_property_space_end_precedence_init         (FoPropertySpaceEndPrecedence      *property_space_end_precedence);
static void fo_property_space_end_precedence_base_class_init   (FoPropertySpaceEndPrecedenceClass *klass);
static void fo_property_space_end_precedence_base_class_finalize   (FoPropertySpaceEndPrecedenceClass *klass);
static void fo_property_space_end_precedence_class_init   (FoPropertySpaceEndPrecedenceClass *klass);
static void fo_property_space_end_precedence_set_property (GObject       *object,
				    guint          prop_id,
				    const GValue  *value,
				    GParamSpec    *pspec);
static void fo_property_space_end_precedence_get_property (GObject       *object,
				    guint          prop_id,
				    GValue        *value,
				    GParamSpec    *pspec);
static void fo_property_space_end_precedence_finalize     (GObject       *object);

FoDatatype* fo_property_space_end_precedence_copy(FoDatatype *datatype);
static FoDatatype* fo_property_space_end_precedence_resolve_enum (const gchar *token,
							 FoContext *context, GError **err);
static FoDatatype* fo_property_space_end_precedence_validate (FoDatatype *datatype,
						     FoContext *context);
static gchar*      fo_property_space_end_precedence_sprintf (FoObject *object);

static gpointer parent_class;
static FoDatatype *enum_force;

GType
fo_property_space_end_precedence_get_type (void)
{
  static GType object_type = 0;

  if (!object_type)
    {
      static const GTypeInfo object_info =
      {
        sizeof (FoPropertySpaceEndPrecedenceClass),
        (GBaseInitFunc) fo_property_space_end_precedence_base_class_init,
        (GBaseFinalizeFunc) fo_property_space_end_precedence_base_class_finalize,
        (GClassInitFunc) fo_property_space_end_precedence_class_init,
        NULL,           /* class_finalize */
        NULL,           /* class_data */
        sizeof (FoPropertySpaceEndPrecedence),
        0,              /* n_preallocs */
        (GInstanceInitFunc) fo_property_space_end_precedence_init,
      };
      
      object_type = g_type_register_static (FO_TYPE_PROPERTY,
                                            "FoPropertySpaceEndPrecedence",
                                            &object_info, 0);
    }
  
  return object_type;
}

static void
fo_property_space_end_precedence_init (FoPropertySpaceEndPrecedence *space_end_precedence)
{
  space_end_precedence->value = NULL;
}

static void
fo_property_space_end_precedence_base_class_init (FoPropertySpaceEndPrecedenceClass *klass)
{
  enum_force =
    g_object_new (FO_TYPE_ENUM,
                  "enum-class",
                  g_type_class_ref (FO_TYPE_ENUM_SPACE_END_PRECEDENCE),
                  "value",
                  FO_ENUM_SPACE_END_PRECEDENCE_FORCE,
                  NULL);
}

static void
fo_property_space_end_precedence_base_class_finalize (FoPropertySpaceEndPrecedenceClass *klass)
{}

static void
fo_property_space_end_precedence_class_init (FoPropertySpaceEndPrecedenceClass *klass)
{
  GObjectClass *object_class = G_OBJECT_CLASS (klass);
  
  parent_class = g_type_class_peek_parent (klass);
  
  object_class->finalize = fo_property_space_end_precedence_finalize;

  object_class->set_property = fo_property_space_end_precedence_set_property;
  object_class->get_property = fo_property_space_end_precedence_get_property;

  g_object_class_install_property (object_class,
                                   PROP_VALUE,
                                   g_param_spec_object ("value",
						     N_("space-end.precedence value"),
						     N_("space-end.precedence property value"),
							FO_TYPE_DATATYPE,
						     G_PARAM_READWRITE));

  FO_PROPERTY_CLASS(klass)->is_inherited = FALSE;
  FO_PROPERTY_CLASS(klass)->new_from_expression =
    fo_property_space_end_precedence_new_from_expression;
  FO_OBJECT_CLASS(klass)->sprintf =
    fo_property_space_end_precedence_sprintf;
  FO_PROPERTY_CLASS(klass)->set_value =
    fo_property_space_end_precedence_set_value;
  FO_PROPERTY_CLASS(klass)->get_value =
    fo_property_space_end_precedence_get_value;
}

static void
fo_property_space_end_precedence_finalize (GObject *object)
{
  FoPropertySpaceEndPrecedence *space_end_precedence;

  space_end_precedence = FO_PROPERTY_SPACE_END_PRECEDENCE (object);

  G_OBJECT_CLASS (parent_class)->finalize (object);
}


static void
fo_property_space_end_precedence_set_property (GObject         *object,
                         guint            prop_id,
                         const GValue    *value,
                         GParamSpec      *pspec)
{
  FoProperty *space_end_precedence;

  space_end_precedence = FO_PROPERTY (object);

  switch (prop_id)
    {
    case PROP_VALUE:
      fo_property_space_end_precedence_set_value (FO_PROPERTY (space_end_precedence), g_value_get_object (value));
      break;
    default:
      G_OBJECT_WARN_INVALID_PROPERTY_ID (object, prop_id, pspec);
      break;
    }
}

static void
fo_property_space_end_precedence_get_property (GObject         *object,
                         guint            prop_id,
                         GValue          *value,
                         GParamSpec      *pspec)
{
  FoProperty *space_end_precedence;

  space_end_precedence = FO_PROPERTY (object);

  switch (prop_id)
    {
    case PROP_VALUE:
      g_value_set_instance (value,
			  fo_property_space_end_precedence_get_value (FO_PROPERTY (space_end_precedence)));
      break;
    default:
      G_OBJECT_WARN_INVALID_PROPERTY_ID (object, prop_id, pspec);
      break;
    }
}

/**
 * fo_property_space_end_precedence_new:
 * 
 * Creates a new #FoPropertySpaceEndPrecedence initialized to default value.
 * 
 * Return value: the new #FoPropertySpaceEndPrecedence
 **/
FoProperty*
fo_property_space_end_precedence_new (void)
{
  FoProperty* space_end_precedence;

  space_end_precedence =
    FO_PROPERTY (g_object_new (fo_property_space_end_precedence_get_type (), NULL));
  
  return space_end_precedence;
}

FoDatatype*
fo_property_space_end_precedence_resolve_enum (const gchar *token, FoContext *context, GError **err)
{
  g_return_val_if_fail (token != NULL, NULL);

  if (strcmp (token, "force") == 0)
    {
      return g_object_ref (enum_force);
    }
  else
    {
      g_warning("Unrecognized space-end.precedence enumeration token: %s", token);
      return NULL;
    }
}

FoDatatype*
fo_property_space_end_precedence_validate (FoDatatype *datatype, FoContext *context)
{
  FoDatatype *new_datatype;
  gchar *token;

  g_return_val_if_fail (datatype != NULL, NULL);
  g_return_val_if_fail (FO_IS_DATATYPE (datatype), NULL);
  g_return_val_if_fail (context != NULL, NULL);
  g_return_val_if_fail (FO_IS_CONTEXT (context), NULL);

  if (FO_IS_SPACE (datatype))
    {
      return datatype;
    }
  else if (FO_IS_LENGTH (datatype))
    {
      return datatype;
    }
  else if (FO_IS_ENUM (datatype))
    {
      if ((G_ENUM_CLASS_TYPE (fo_enum_get_enum_class (datatype))
           == FO_TYPE_ENUM_SPACE_END_PRECEDENCE) &&
	  (g_enum_get_value (fo_enum_get_enum_class (datatype),
			     fo_enum_get_value (datatype)) != NULL))
	{
	  return datatype;
	}
      else
	{
	  g_object_unref (datatype);

	  return NULL;
	}
    }
  else if (FO_IS_STRING (datatype))
    {
      token = fo_string_get_value (datatype);

      new_datatype = fo_property_space_end_precedence_resolve_enum (token, context, NULL);

      g_object_unref (datatype);

      return new_datatype;
    }
  else if (FO_IS_NAME (datatype))
    {
      token = fo_name_get_value (datatype);

      new_datatype = fo_property_space_end_precedence_resolve_enum (token, context, NULL);

      g_object_unref (datatype);

      return new_datatype;
    }
  else
    {
      g_warning("Invalid space-end.precedence datatype: %s (%s)",
	        fo_object_sprintf (FO_OBJECT (datatype)),
		g_type_name(G_TYPE_FROM_INSTANCE (datatype)));

      g_object_unref (datatype);

      return NULL;
    }
}

FoProperty*
fo_property_space_end_precedence_new_from_expression (const gchar *expression,
					   FoContext *context,
					   FoProperty *current_font_size,
					   FoFo *fo_node,
					   GError **error)
{
  FoProperty *space_end_precedence;
  FoDatatype *datatype;

  g_return_val_if_fail (expression != NULL, NULL);
  g_return_val_if_fail (context != NULL, NULL);
  g_return_val_if_fail (FO_IS_CONTEXT (context), NULL);
  g_return_val_if_fail
    (current_font_size == NULL || FO_IS_PROPERTY_FONT_SIZE (current_font_size),
     NULL);

  space_end_precedence = fo_property_space_end_precedence_new ();

  datatype =
    fo_property_eval_expression (expression,
				 "space-end.precedence",
				 context,
				 fo_property_space_end_precedence_resolve_enum,
				 current_font_size,
				 fo_node);

  datatype = fo_property_space_end_precedence_validate (datatype, context);

  fo_property_space_end_precedence_set_value (space_end_precedence, datatype);

  return space_end_precedence;
}

/* value */
void
fo_property_space_end_precedence_set_value (FoProperty *property,
		       FoDatatype *new_value)
{
  FoPropertySpaceEndPrecedence *space_end_precedence;

  g_return_if_fail (property != NULL);

  space_end_precedence = FO_PROPERTY_SPACE_END_PRECEDENCE (property);

  space_end_precedence->value = new_value;
  /*g_object_notify(G_OBJECT(space_end_precedence), "value");*/
}

FoDatatype*
fo_property_space_end_precedence_get_value (FoProperty *property)
{
  FoPropertySpaceEndPrecedence *space_end_precedence;

  g_return_val_if_fail (property != NULL, NULL);

  space_end_precedence = FO_PROPERTY_SPACE_END_PRECEDENCE (property);

  return space_end_precedence->value;
}

gchar*
fo_property_space_end_precedence_sprintf (FoObject *object)
{
  FoProperty *space_end_precedence;
  FoDatatype *datatype;

  g_return_val_if_fail (object != NULL, NULL);

  space_end_precedence = FO_PROPERTY (object);
  datatype = fo_property_space_end_precedence_get_value (space_end_precedence);

  return
    g_strdup_printf ("space-end.precedence: %s",
		     fo_object_sprintf (FO_OBJECT (datatype)));
}

FoProperty*
fo_property_space_end_precedence_get_initial (void)
{
  static FoProperty *space_end_precedence = NULL;

  if (!space_end_precedence)
    {
      space_end_precedence = fo_property_space_end_precedence_new ();

      fo_property_space_end_precedence_set_value (space_end_precedence,
					  g_object_new (FO_TYPE_INTEGER,
							"value",
							0,
							NULL));
    }

  return space_end_precedence;
}
