/* Fo
 * fo-property-space-start-minimum.h: space-start.minimum property
 *
 * Copyright (C) 2001 Sun Microsystems
 *
 * $Id: fo-property-space-start-minimum.h,v 1.2 2003/03/21 14:41:45 tonygraham Exp $
 *
 * See Copyright for the status of this software.
 */

#ifndef __FO_PROPERTY_SPACE_START_MINIMUM_H__
#define __FO_PROPERTY_SPACE_START_MINIMUM_H__

#include <libfo/fo-utils.h>
#include "fo-context.h"

G_BEGIN_DECLS

/* space-start */
/* <space> | inherit */
/* Disallow 'inherit' since this is a component of a compound property */
/* therefore *no* enumeration tokens */

#define FO_TYPE_PROPERTY_SPACE_START_MINIMUM              (fo_property_space_start_minimum_get_type ())
#define FO_PROPERTY_SPACE_START_MINIMUM(object)           (G_TYPE_CHECK_INSTANCE_CAST ((object), FO_TYPE_PROPERTY_SPACE_START_MINIMUM, FoPropertySpaceStartMinimum))
#define FO_PROPERTY_SPACE_START_MINIMUM_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST ((klass), FO_TYPE_PROPERTY_SPACE_START_MINIMUM, FoPropertySpaceStartMinimumClass))
#define FO_IS_PROPERTY_SPACE_START_MINIMUM(object)        (G_TYPE_CHECK_INSTANCE_TYPE ((object), FO_TYPE_PROPERTY_SPACE_START_MINIMUM))
#define FO_IS_PROPERTY_SPACE_START_MINIMUM_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), FO_TYPE_PROPERTY_SPACE_START_MINIMUM))
#define FO_PROPERTY_SPACE_START_MINIMUM_GET_CLASS(obj)    (G_TYPE_INSTANCE_GET_CLASS ((obj), FO_TYPE_PROPERTY_SPACE_START_MINIMUM, FoPropertySpaceStartMinimumClass))


typedef struct _FoPropertySpaceStartMinimum      FoPropertySpaceStartMinimum;
typedef struct _FoPropertySpaceStartMinimumClass FoPropertySpaceStartMinimumClass;

GType       fo_property_space_start_minimum_get_type      (void) G_GNUC_CONST;
FoProperty* fo_property_space_start_minimum_new           (void);

void fo_property_space_start_minimum_set_value (FoProperty *property,
		      FoDatatype *new_value);
FoDatatype* fo_property_space_start_minimum_get_value (FoProperty *property);
FoProperty* fo_property_space_start_minimum_new_from_expression (const gchar *expression,
						    FoContext   *context,
						    FoProperty    *current_font_size,
							 FoFo *fo_node,
                                            GError    **error);
FoProperty* fo_property_space_start_minimum_get_initial (void);

G_END_DECLS

#endif /* !__FO_PROPERTY_SPACE_START_MINIMUM_H__ */
