/* Fo
 * fo-property-table-layout.h: table-layout property
 *
 * Copyright (C) 2001 Sun Microsystems
 *
 * $Id: fo-property-table-layout.h,v 1.2 2003/03/21 14:41:45 tonygraham Exp $
 *
 * See Copying for the status of this software.
 */

#ifndef __FO_PROPERTY_TABLE_LAYOUT_H__
#define __FO_PROPERTY_TABLE_LAYOUT_H__

#include <libfo/fo-utils.h>
#include "fo-context.h"

G_BEGIN_DECLS

/* table-layout */
/* auto | fixed | inherit */
typedef enum {
  FO_ENUM_TABLE_LAYOUT_AUTO,
  FO_ENUM_TABLE_LAYOUT_FIXED,
  FO_ENUM_TABLE_LAYOUT_INHERIT
} FoEnumTableLayout;

GType fo_enum_table_layout_get_type (void);
#define FO_TYPE_ENUM_TABLE_LAYOUT fo_enum_table_layout_get_type ()

#define FO_TYPE_PROPERTY_TABLE_LAYOUT              (fo_property_table_layout_get_type ())
#define FO_PROPERTY_TABLE_LAYOUT(object)           (G_TYPE_CHECK_INSTANCE_CAST ((object), FO_TYPE_PROPERTY_TABLE_LAYOUT, FoPropertyTableLayout))
#define FO_PROPERTY_TABLE_LAYOUT_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST ((klass), FO_TYPE_PROPERTY_TABLE_LAYOUT, FoPropertyTableLayoutClass))
#define FO_IS_PROPERTY_TABLE_LAYOUT(object)        (G_TYPE_CHECK_INSTANCE_TYPE ((object), FO_TYPE_PROPERTY_TABLE_LAYOUT))
#define FO_IS_PROPERTY_TABLE_LAYOUT_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), FO_TYPE_PROPERTY_TABLE_LAYOUT))
#define FO_PROPERTY_TABLE_LAYOUT_GET_CLASS(obj)    (G_TYPE_INSTANCE_GET_CLASS ((obj), FO_TYPE_PROPERTY_TABLE_LAYOUT, FoPropertyTableLayoutClass))


typedef struct _FoPropertyTableLayout      FoPropertyTableLayout;
typedef struct _FoPropertyTableLayoutClass FoPropertyTableLayoutClass;

GType       fo_property_table_layout_get_type      (void) G_GNUC_CONST;
FoProperty* fo_property_table_layout_new           (void);

void fo_property_table_layout_set_value (FoProperty *property,
                                         FoDatatype *new_value);
FoDatatype* fo_property_table_layout_get_value (FoProperty *property);
FoProperty* fo_property_table_layout_new_from_expression (const gchar *expression,
                                                          FoContext   *context,
                                                          FoProperty  *current_font_size,
                                                          FoFo        *fo_node,
                                                          GError     **error);
FoProperty* fo_property_table_layout_get_initial (void);

G_END_DECLS

#endif /* !__FO_PROPERTY_TABLE_LAYOUT_H__ */
